class FloorController < ApplicationController
  def internal
	# A method that does things that all views need
	@departments = Aisle.all
	@flogit = Product.all.sort_by(&:unitprice).reverse
  end

  def index
	# Bring in the common stuff
	internal
	# which is all this example needs on its basic stuff!
  end

  def stock
	# Bring in the common stuff
	internal

	# Because we are within a class / on an object, we
	# can just refer to @based (object) variables from our
	# internal method as they are quasi-global
	@flogit = @flogit.reverse

	# Code up stuff for the stock table display
	# Leave a "protected" [wrong word!] copy of base data
	# Note - don't really need clone - we could let sort 
	# produce the cloned copy because we happen to be sorting
	@catalog = @flogit.clone

	@catalog = @catalog.sort_by(&:aisle_id)
	# In this example, show is just an array of strings
	# in a more complex example, it would be an array of
	# objects of potenially different types which the viewer
	# would format as appropriate using the polymorphic
	# capabilities of each of those types
	@show = []
	old_aisle = -1
	counter = 0

	@catalog.each do |thing|
		if old_aisle != thing.aisle_id
			if counter > 0
				@show.push("Total of #{counter}\n")
				end
			@show.push("Into a new aisle #{thing.aisle.aname}")
			old_aisle = thing.aisle_id
			counter = 0
		end
		counter += 1
		@show.push("... #{counter} - selling #{thing.pname}")
	end
	# Duplicate summary line / should be a function/method call
	# if it's any more complex, as it is duplicating
	@show.push("Total of #{counter}\n")
  end

  def addaisle
	# Put up the form to add in a new aisle
	internal
	@newrange = Aisle.new
	end

  def addproduct
	# Put up the form to add in a new product
	internal
	@newprod = Product.new
	internal_aisles
	end

  def internal_aisles	
	@avail_aisles = []
	@departments.each do |store_area|
		if store_area.id == params[:id].to_i
@avail_aisles.unshift(["#{store_area.aname} [def]", store_area.id])
		else
@avail_aisles.push([store_area.aname, store_area.id])
		end
	end

	end

  def saveproduct
	# Pick up the values for a new product
	@newprod = Product.new(params[:product])
	# Does the aisle it will be on exist?
	matches = Aisle.exists?(@newprod.aisle_id)

	# Create a new product record if on an aisle
	# Note - making use of lazy "and" operator
	if matches and @newprod.save

	# If it worked
	# send them back to the basic display
	# NOT USING EXISTING OBJECT VARS
	redirect_to :action => "index"

	else

	# If it failed
	# reshow this display WITH EXISTING OBJECT VARS
	internal
	internal_aisles
	render :action => "addproduct"

	end

	end

  def saveaisle

	# Pick up the values for a new aisle
	@newrange = Aisle.new(params[:aisle])

	# Create a new aisle record
	if @newrange.save

	# And send them back to the basic display
	redirect_to :action => "index"

	else
	internal
	render :action => "addaisle"
	end
	end
end
